/********************************************************/
/* Copyright 1999, Chengjie Tu & Trac Duy Tran          */
/* All rights reserved                                  */
/* File: "bitstream.C"                                  */
/* Description: Huffman codec class                     */
/* Affiliation: Johns Hopkins University, Baltimore, MD */
/*              FastVideo LLC, Columbia, MD             */
/********************************************************/

#include<iostream.h>
#include"bitstream.h"

bool OutBitStream::CodeBit(bool bit)
{
  _data<<=1; //ready for next bit
  if(!bit)   //code next bit
    _data++;
  _pos++;   //updata bit position
  
  if(_pos==8) //buffer is full
  {
    _out.put(_data);  //output it
    _data=0;          //reset buffer
    _pos=0;
    _size++;          //count
  }
  
  return bit;
}

void OutBitStream::Flush(void)
{
  if(_pos>0) //flush buffer
    _out.put(_data<<(8-_pos));
}

bool InBitStream::DecodeBit(void)
{
  bool bit;
  
  if(_pos==0) //buffer is empty
  {
    _in.get(_data);  //read to buffer
    _pos=8;          //point to first bit
    _size++;         //count
  }
  
  bit=(_data<0x80); //'0' or '1'?
  _pos--;           //next bit
  _data<<=1;
  
  return bit;
}
