/********************************************************/
/* Copyright 1999, Chengjie Tu & Trac Duy Tran          */
/* All rights reserved                                  */
/* File: "bitstream.h"                                  */
/* Description: bitstream class                         */
/* Affiliation: Johns Hopkins University, Baltimore, MD */
/*              FastVideo LLC, Columbia, MD             */
/********************************************************/

#ifndef BITSTREAM_H
#define BITSTREAM_H

class BitStream  //bitstream class
{
 public:
  unsigned BytesUsed(void){return _size;} //how many bytes used

 protected:
  BitStream(void):_data(0),_size(0),_pos(0){} //constructor
  unsigned char _data;     //buffer
  unsigned _size;          //how many bytes used
  unsigned _pos;           //bit position
};

class OutBitStream:public BitStream //outgoing bitstream
{
 public:
  OutBitStream(class ostream& out):_out(out){} //constructor
  bool CodeBit(bool); //code a bit
  void Flush(void); //flush output
  
 private:
  class ostream& _out;  //where bitstream goes
};

class InBitStream:public BitStream //incoming bitstream
{
 public:
  InBitStream(class istream& in):_in(in){} //constructor
  bool DecodeBit(void); //decode a bit
  
 private:
  class istream& _in; //where bitstream comes from
};

#endif
