#include<iostream.h>
#include<fstream.h>

#include"bitstream.h"
#include"huffman.h"

int main(int argc,char** argv)
{
  if(argc!=4)
  {
    cout<<"Usage: "<<argv[0]<<" huffman_table compressed_bitstream reconstructed_bitstream"<<endl;
    return -1;
  }

  ifstream codebook(argv[1],ios::in|ios::binary);
  if(!codebook)
  {
    cout<<"Open file "<<argv[1]<<" failed."<<endl;
    return -1;
  }

  unsigned size;
  codebook>>size;
  int* symbol=new int[size];
  unsigned* frequency=new unsigned[size];

  codebook.read(reinterpret_cast<char*>(symbol),size*sizeof(unsigned));
  unsigned foo=codebook.gcount();
  codebook.read(reinterpret_cast<char*>(frequency),size*sizeof(unsigned));
  unsigned bar=codebook.gcount();
  codebook.close();
  if(foo!=size*sizeof(unsigned)||bar!=size*sizeof(unsigned))
  {
    cout<<"Bad huffman table"<<endl;
    return -2;
  }

  ifstream code(argv[2],ios::in|ios::binary);
  if(!code)
  {
    cout<<"Open file "<<argv[2]<<" failed."<<endl;
    return -3;
  }

  ofstream out(argv[3],ios::out|ios::binary);
  if(!out)
  {
    cout<<"Open file "<<argv[3]<<" failed."<<endl;
    return -4;
  }

  InBitStream* bitstream=new InBitStream(code);
  Huffman* huffman=new Huffman(size,symbol,frequency);

  foo=0;
  while(!code.eof())
  {
    int gah=huffman->DecodeSymbol(*bitstream);
    if(gah==symbol[size-1])
      {
	cout<<"**********"<<endl;
      break;
      }
    foo++;
    out.put(gah);
  }

  delete bitstream;
  delete huffman;
  delete symbol;
  delete frequency;
  code.close();
  out.close();

  cout<<endl<<foo<<" bytes decoded."<<endl<<endl;
  return 0;
}
