#include<iostream.h>
#include<fstream.h>

#include"bitstream.h"
#include"huffman.h"

int main(int argc,char** argv)
{
  if(argc!=4)
  {
    cout<<"Usage: "<<argv[0]<<" filename huffman_table compressed_bitstream"<<endl;
    return -1;
  }

  ifstream in(argv[1],ios::in|ios::binary);
  if(!in)
  {
    cout<<"Open file "<<argv[1]<<" failed."<<endl;
    return -1;
  }

  unsigned size=257;
  int* symbol=new int[size];
  unsigned* frequency=new unsigned[size];

  for(unsigned i=0;i<size;i++)
    symbol[i]=i,frequency[i]=0;
  symbol[size-1]=0xffffffff;
  frequency[size-1]=1;

  ofstream codebook(argv[2],ios::out|ios::binary);
  ofstream code(argv[3],ios::out|ios::binary);
  
  unsigned total=0;
  while(in.peek()!=EOF)
    frequency[in.get()]++,total++;

  codebook<<size;
  codebook.write(reinterpret_cast<char*>(symbol),size*sizeof(int));
  codebook.write(reinterpret_cast<char*>(frequency),size*sizeof(unsigned));
  codebook.close();

  OutBitStream* bitstream=new OutBitStream(code);
  Huffman* huffman=new Huffman(size,symbol,frequency);

  //  in.seekg(0,ios::end);
  in.close();
  in.open(argv[1],ios::in|ios::binary);
  while(in.peek()!=EOF)
    huffman->CodeSymbol(in.get(),*bitstream);
  huffman->CodeSymbol(symbol[size-1],*bitstream);
  bitstream->Flush();
  huffman->ShowCodeBook(cout);
  cout<<endl<<total<<'/'<<bitstream->BytesUsed()<<" bytes before/after coding, ";
  cout<<1.0*total/bitstream->BytesUsed()<<":1 compression"<<endl<<endl;

  delete bitstream;
  delete huffman;
  delete symbol;
  delete frequency;
  code.close();
  in.close();

  return 0;
}
